/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IClass2MessagesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Forwarding messages to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus ForwardMessage (ForwardMessageRequest forwardMessageRequest);

        /// <summary>
        /// Forwarding messages to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> ForwardMessageWithHttpInfo (ForwardMessageRequest forwardMessageRequest);
        /// <summary>
        /// Get a list of messages.
        /// </summary>
        /// <remarks>
        /// To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Messages</returns>
        Messages GetMessages (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int));

        /// <summary>
        /// Get a list of messages.
        /// </summary>
        /// <remarks>
        /// To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>ApiResponse of Messages</returns>
        ApiResponse<Messages> GetMessagesWithHttpInfo (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int));
        /// <summary>
        /// Sending a contact or contact list to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendContact (SendContactRequest sendContactRequest);

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendContactWithHttpInfo (SendContactRequest sendContactRequest);
        /// <summary>
        /// Send a file to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendFile (SendFileRequest sendFileRequest);

        /// <summary>
        /// Send a file to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendFileWithHttpInfo (SendFileRequest sendFileRequest);
        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendLink (SendLinkRequest sendLinkRequest);

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendLinkWithHttpInfo (SendLinkRequest sendLinkRequest);
        /// <summary>
        /// Sending a location to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendLocation (SendLocationRequest sendLocationRequest);

        /// <summary>
        /// Sending a location to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendLocationWithHttpInfo (SendLocationRequest sendLocationRequest);
        /// <summary>
        /// Send a message to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendMessage (SendMessageRequest sendMessageRequest);

        /// <summary>
        /// Send a message to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendMessageWithHttpInfo (SendMessageRequest sendMessageRequest);
        /// <summary>
        /// Send a ptt-audio to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendPTT (SendPTTRequest sendPTTRequest);

        /// <summary>
        /// Send a ptt-audio to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendPTTWithHttpInfo (SendPTTRequest sendPTTRequest);
        /// <summary>
        /// Sending a vcard to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>SendMessageStatus</returns>
        SendMessageStatus SendVCard (SendVCardRequest sendVCardRequest);

        /// <summary>
        /// Sending a vcard to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        ApiResponse<SendMessageStatus> SendVCardWithHttpInfo (SendVCardRequest sendVCardRequest);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Forwarding messages to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> ForwardMessageAsync (ForwardMessageRequest forwardMessageRequest);

        /// <summary>
        /// Forwarding messages to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> ForwardMessageAsyncWithHttpInfo (ForwardMessageRequest forwardMessageRequest);
        /// <summary>
        /// Get a list of messages.
        /// </summary>
        /// <remarks>
        /// To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Task of Messages</returns>
        System.Threading.Tasks.Task<Messages> GetMessagesAsync (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int));

        /// <summary>
        /// Get a list of messages.
        /// </summary>
        /// <remarks>
        /// To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Task of ApiResponse (Messages)</returns>
        System.Threading.Tasks.Task<ApiResponse<Messages>> GetMessagesAsyncWithHttpInfo (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int));
        /// <summary>
        /// Sending a contact or contact list to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendContactAsync (SendContactRequest sendContactRequest);

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendContactAsyncWithHttpInfo (SendContactRequest sendContactRequest);
        /// <summary>
        /// Send a file to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendFileAsync (SendFileRequest sendFileRequest);

        /// <summary>
        /// Send a file to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendFileAsyncWithHttpInfo (SendFileRequest sendFileRequest);
        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendLinkAsync (SendLinkRequest sendLinkRequest);

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendLinkAsyncWithHttpInfo (SendLinkRequest sendLinkRequest);
        /// <summary>
        /// Sending a location to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendLocationAsync (SendLocationRequest sendLocationRequest);

        /// <summary>
        /// Sending a location to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendLocationAsyncWithHttpInfo (SendLocationRequest sendLocationRequest);
        /// <summary>
        /// Send a message to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendMessageAsync (SendMessageRequest sendMessageRequest);

        /// <summary>
        /// Send a message to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendMessageAsyncWithHttpInfo (SendMessageRequest sendMessageRequest);
        /// <summary>
        /// Send a ptt-audio to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendPTTAsync (SendPTTRequest sendPTTRequest);

        /// <summary>
        /// Send a ptt-audio to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendPTTAsyncWithHttpInfo (SendPTTRequest sendPTTRequest);
        /// <summary>
        /// Sending a vcard to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        System.Threading.Tasks.Task<SendMessageStatus> SendVCardAsync (SendVCardRequest sendVCardRequest);

        /// <summary>
        /// Sending a vcard to a new or existing chat.
        /// </summary>
        /// <remarks>
        /// Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendVCardAsyncWithHttpInfo (SendVCardRequest sendVCardRequest);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class Class2MessagesApi : IClass2MessagesApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="Class2MessagesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public Class2MessagesApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class2MessagesApi"/> class
        /// </summary>
        /// <returns></returns>
        public Class2MessagesApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class2MessagesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public Class2MessagesApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Forwarding messages to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus ForwardMessage (ForwardMessageRequest forwardMessageRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = ForwardMessageWithHttpInfo(forwardMessageRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Forwarding messages to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> ForwardMessageWithHttpInfo (ForwardMessageRequest forwardMessageRequest)
        {
            // verify the required parameter 'forwardMessageRequest' is set
            if (forwardMessageRequest == null)
                throw new ApiException(400, "Missing required parameter 'forwardMessageRequest' when calling Class2MessagesApi->ForwardMessage");

            var localVarPath = "/forwardMessage";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (forwardMessageRequest != null && forwardMessageRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(forwardMessageRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = forwardMessageRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ForwardMessage", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Forwarding messages to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> ForwardMessageAsync (ForwardMessageRequest forwardMessageRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await ForwardMessageAsyncWithHttpInfo(forwardMessageRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Forwarding messages to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="forwardMessageRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> ForwardMessageAsyncWithHttpInfo (ForwardMessageRequest forwardMessageRequest)
        {
            // verify the required parameter 'forwardMessageRequest' is set
            if (forwardMessageRequest == null)
                throw new ApiException(400, "Missing required parameter 'forwardMessageRequest' when calling Class2MessagesApi->ForwardMessage");

            var localVarPath = "/forwardMessage";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (forwardMessageRequest != null && forwardMessageRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(forwardMessageRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = forwardMessageRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ForwardMessage", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Get a list of messages. To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Messages</returns>
        public Messages GetMessages (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int))
        {
             ApiResponse<Messages> localVarResponse = GetMessagesWithHttpInfo(lastMessageNumber, last, chatId, limit, minTime, maxTime);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get a list of messages. To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>ApiResponse of Messages</returns>
        public ApiResponse<Messages> GetMessagesWithHttpInfo (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int))
        {

            var localVarPath = "/messages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (lastMessageNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lastMessageNumber", lastMessageNumber)); // query parameter
            if (last != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last", last)); // query parameter
            if (chatId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "chatId", chatId)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (minTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "min_time", minTime)); // query parameter
            if (maxTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "max_time", maxTime)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetMessages", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Messages>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Messages) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Messages)));
        }

        /// <summary>
        /// Get a list of messages. To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Task of Messages</returns>
        public async System.Threading.Tasks.Task<Messages> GetMessagesAsync (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int))
        {
             ApiResponse<Messages> localVarResponse = await GetMessagesAsyncWithHttpInfo(lastMessageNumber, last, chatId, limit, minTime, maxTime);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get a list of messages. To receive only new messages, pass the **lastMessageNumber** parameter from the last query.  Files from messages are guaranteed to be stored only for 30 days and can be deleted. Download the files as soon as you get to your server.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="lastMessageNumber">The lastMessageNumber parameter from the last response (optional)</param>
        /// <param name="last">Displays the last 100 messages. If this parameter is passed, then lastMessageNumber is ignored. (optional, default to false)</param>
        /// <param name="chatId">Filter messages by chatId  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. (optional)</param>
        /// <param name="limit">Sets length of the message list. Default 100. With value 0 returns all messages. (optional)</param>
        /// <param name="minTime">Filter messages received after specified time. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter messages received before specified time. Example: 946684800. (optional)</param>
        /// <returns>Task of ApiResponse (Messages)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Messages>> GetMessagesAsyncWithHttpInfo (int lastMessageNumber = default(int), bool last = default(bool), string chatId = default(string), int limit = default(int), int minTime = default(int), int maxTime = default(int))
        {

            var localVarPath = "/messages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (lastMessageNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lastMessageNumber", lastMessageNumber)); // query parameter
            if (last != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "last", last)); // query parameter
            if (chatId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "chatId", chatId)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (minTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "min_time", minTime)); // query parameter
            if (maxTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "max_time", maxTime)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetMessages", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Messages>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Messages) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Messages)));
        }

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendContact (SendContactRequest sendContactRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendContactWithHttpInfo(sendContactRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendContactWithHttpInfo (SendContactRequest sendContactRequest)
        {
            // verify the required parameter 'sendContactRequest' is set
            if (sendContactRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendContactRequest' when calling Class2MessagesApi->SendContact");

            var localVarPath = "/sendContact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendContactRequest != null && sendContactRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendContactRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendContactRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendContact", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendContactAsync (SendContactRequest sendContactRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendContactAsyncWithHttpInfo(sendContactRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Sending a contact or contact list to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendContactRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendContactAsyncWithHttpInfo (SendContactRequest sendContactRequest)
        {
            // verify the required parameter 'sendContactRequest' is set
            if (sendContactRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendContactRequest' when calling Class2MessagesApi->SendContact");

            var localVarPath = "/sendContact";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendContactRequest != null && sendContactRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendContactRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendContactRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendContact", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a file to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendFile (SendFileRequest sendFileRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendFileWithHttpInfo(sendFileRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send a file to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendFileWithHttpInfo (SendFileRequest sendFileRequest)
        {
            // verify the required parameter 'sendFileRequest' is set
            if (sendFileRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendFileRequest' when calling Class2MessagesApi->SendFile");

            var localVarPath = "/sendFile";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendFileRequest != null && sendFileRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendFileRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendFileRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendFile", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a file to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendFileAsync (SendFileRequest sendFileRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendFileAsyncWithHttpInfo(sendFileRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send a file to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendFileRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendFileAsyncWithHttpInfo (SendFileRequest sendFileRequest)
        {
            // verify the required parameter 'sendFileRequest' is set
            if (sendFileRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendFileRequest' when calling Class2MessagesApi->SendFile");

            var localVarPath = "/sendFile";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendFileRequest != null && sendFileRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendFileRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendFileRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendFile", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendLink (SendLinkRequest sendLinkRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendLinkWithHttpInfo(sendLinkRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendLinkWithHttpInfo (SendLinkRequest sendLinkRequest)
        {
            // verify the required parameter 'sendLinkRequest' is set
            if (sendLinkRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendLinkRequest' when calling Class2MessagesApi->SendLink");

            var localVarPath = "/sendLink";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendLinkRequest != null && sendLinkRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendLinkRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendLinkRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendLink", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendLinkAsync (SendLinkRequest sendLinkRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendLinkAsyncWithHttpInfo(sendLinkRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send text with link and link&#39;s preview to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLinkRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendLinkAsyncWithHttpInfo (SendLinkRequest sendLinkRequest)
        {
            // verify the required parameter 'sendLinkRequest' is set
            if (sendLinkRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendLinkRequest' when calling Class2MessagesApi->SendLink");

            var localVarPath = "/sendLink";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendLinkRequest != null && sendLinkRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendLinkRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendLinkRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendLink", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Sending a location to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendLocation (SendLocationRequest sendLocationRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendLocationWithHttpInfo(sendLocationRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Sending a location to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendLocationWithHttpInfo (SendLocationRequest sendLocationRequest)
        {
            // verify the required parameter 'sendLocationRequest' is set
            if (sendLocationRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendLocationRequest' when calling Class2MessagesApi->SendLocation");

            var localVarPath = "/sendLocation";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendLocationRequest != null && sendLocationRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendLocationRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendLocationRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendLocation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Sending a location to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendLocationAsync (SendLocationRequest sendLocationRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendLocationAsyncWithHttpInfo(sendLocationRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Sending a location to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendLocationRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendLocationAsyncWithHttpInfo (SendLocationRequest sendLocationRequest)
        {
            // verify the required parameter 'sendLocationRequest' is set
            if (sendLocationRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendLocationRequest' when calling Class2MessagesApi->SendLocation");

            var localVarPath = "/sendLocation";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendLocationRequest != null && sendLocationRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendLocationRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendLocationRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendLocation", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a message to a new or existing chat. The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendMessage (SendMessageRequest sendMessageRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendMessageWithHttpInfo(sendMessageRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send a message to a new or existing chat. The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendMessageWithHttpInfo (SendMessageRequest sendMessageRequest)
        {
            // verify the required parameter 'sendMessageRequest' is set
            if (sendMessageRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendMessageRequest' when calling Class2MessagesApi->SendMessage");

            var localVarPath = "/sendMessage";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendMessageRequest != null && sendMessageRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendMessageRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendMessageRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendMessage", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a message to a new or existing chat. The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendMessageAsync (SendMessageRequest sendMessageRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendMessageAsyncWithHttpInfo(sendMessageRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send a message to a new or existing chat. The message will be added to the queue for sending and delivered even if the phone is disconnected from the Internet or authorization is not passed.  Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendMessageRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendMessageAsyncWithHttpInfo (SendMessageRequest sendMessageRequest)
        {
            // verify the required parameter 'sendMessageRequest' is set
            if (sendMessageRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendMessageRequest' when calling Class2MessagesApi->SendMessage");

            var localVarPath = "/sendMessage";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendMessageRequest != null && sendMessageRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendMessageRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendMessageRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendMessage", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a ptt-audio to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendPTT (SendPTTRequest sendPTTRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendPTTWithHttpInfo(sendPTTRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send a ptt-audio to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendPTTWithHttpInfo (SendPTTRequest sendPTTRequest)
        {
            // verify the required parameter 'sendPTTRequest' is set
            if (sendPTTRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendPTTRequest' when calling Class2MessagesApi->SendPTT");

            var localVarPath = "/sendPTT";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendPTTRequest != null && sendPTTRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendPTTRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendPTTRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendPTT", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Send a ptt-audio to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendPTTAsync (SendPTTRequest sendPTTRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendPTTAsyncWithHttpInfo(sendPTTRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send a ptt-audio to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendPTTRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendPTTAsyncWithHttpInfo (SendPTTRequest sendPTTRequest)
        {
            // verify the required parameter 'sendPTTRequest' is set
            if (sendPTTRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendPTTRequest' when calling Class2MessagesApi->SendPTT");

            var localVarPath = "/sendPTT";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendPTTRequest != null && sendPTTRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendPTTRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendPTTRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendPTT", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Sending a vcard to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>SendMessageStatus</returns>
        public SendMessageStatus SendVCard (SendVCardRequest sendVCardRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = SendVCardWithHttpInfo(sendVCardRequest);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Sending a vcard to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>ApiResponse of SendMessageStatus</returns>
        public ApiResponse<SendMessageStatus> SendVCardWithHttpInfo (SendVCardRequest sendVCardRequest)
        {
            // verify the required parameter 'sendVCardRequest' is set
            if (sendVCardRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendVCardRequest' when calling Class2MessagesApi->SendVCard");

            var localVarPath = "/sendVCard";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendVCardRequest != null && sendVCardRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendVCardRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendVCardRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendVCard", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

        /// <summary>
        /// Sending a vcard to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>Task of SendMessageStatus</returns>
        public async System.Threading.Tasks.Task<SendMessageStatus> SendVCardAsync (SendVCardRequest sendVCardRequest)
        {
             ApiResponse<SendMessageStatus> localVarResponse = await SendVCardAsyncWithHttpInfo(sendVCardRequest);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Sending a vcard to a new or existing chat. Only one of two parameters is needed to determine the destination - chatId or phone.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="sendVCardRequest"></param>
        /// <returns>Task of ApiResponse (SendMessageStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SendMessageStatus>> SendVCardAsyncWithHttpInfo (SendVCardRequest sendVCardRequest)
        {
            // verify the required parameter 'sendVCardRequest' is set
            if (sendVCardRequest == null)
                throw new ApiException(400, "Missing required parameter 'sendVCardRequest' when calling Class2MessagesApi->SendVCard");

            var localVarPath = "/sendVCard";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (sendVCardRequest != null && sendVCardRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(sendVCardRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = sendVCardRequest; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SendVCard", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SendMessageStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (SendMessageStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(SendMessageStatus)));
        }

    }
}
