/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IClass3ChatsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Adding participant to a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        GroupParticipantStatus AddGroupParticipant (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Adding participant to a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        ApiResponse<GroupParticipantStatus> AddGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Demote group participant
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        GroupParticipantStatus DemoteGroupParticipant (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Demote group participant
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        ApiResponse<GroupParticipantStatus> DemoteGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Get the chat list.
        /// </summary>
        /// <remarks>
        /// The chat list includes avatars.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Chats</returns>
        Chats GetChats ();

        /// <summary>
        /// Get the chat list.
        /// </summary>
        /// <remarks>
        /// The chat list includes avatars.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of Chats</returns>
        ApiResponse<Chats> GetChatsWithHttpInfo ();
        /// <summary>
        /// Creates a group and sends the message to the created group.
        /// </summary>
        /// <remarks>
        /// The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>CreateGroupStatus</returns>
        CreateGroupStatus Group (CreateGroupAction createGroupAction);

        /// <summary>
        /// Creates a group and sends the message to the created group.
        /// </summary>
        /// <remarks>
        /// The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>ApiResponse of CreateGroupStatus</returns>
        ApiResponse<CreateGroupStatus> GroupWithHttpInfo (CreateGroupAction createGroupAction);
        /// <summary>
        /// Make participant in the group an administrator
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        GroupParticipantStatus PromoteGroupParticipant (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Make participant in the group an administrator
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        ApiResponse<GroupParticipantStatus> PromoteGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Open chat for reading messages
        /// </summary>
        /// <remarks>
        /// Use this method to make users see their messages read.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>ReadChatStatus</returns>
        ReadChatStatus ReadChat (ReadChatAction readChatAction);

        /// <summary>
        /// Open chat for reading messages
        /// </summary>
        /// <remarks>
        /// Use this method to make users see their messages read.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>ApiResponse of ReadChatStatus</returns>
        ApiResponse<ReadChatStatus> ReadChatWithHttpInfo (ReadChatAction readChatAction);
        /// <summary>
        /// Remove participant from a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        GroupParticipantStatus RemoveGroupParticipant (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Remove participant from a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        ApiResponse<GroupParticipantStatus> RemoveGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Adding participant to a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        System.Threading.Tasks.Task<GroupParticipantStatus> AddGroupParticipantAsync (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Adding participant to a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> AddGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Demote group participant
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        System.Threading.Tasks.Task<GroupParticipantStatus> DemoteGroupParticipantAsync (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Demote group participant
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> DemoteGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Get the chat list.
        /// </summary>
        /// <remarks>
        /// The chat list includes avatars.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of Chats</returns>
        System.Threading.Tasks.Task<Chats> GetChatsAsync ();

        /// <summary>
        /// Get the chat list.
        /// </summary>
        /// <remarks>
        /// The chat list includes avatars.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (Chats)</returns>
        System.Threading.Tasks.Task<ApiResponse<Chats>> GetChatsAsyncWithHttpInfo ();
        /// <summary>
        /// Creates a group and sends the message to the created group.
        /// </summary>
        /// <remarks>
        /// The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>Task of CreateGroupStatus</returns>
        System.Threading.Tasks.Task<CreateGroupStatus> GroupAsync (CreateGroupAction createGroupAction);

        /// <summary>
        /// Creates a group and sends the message to the created group.
        /// </summary>
        /// <remarks>
        /// The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>Task of ApiResponse (CreateGroupStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<CreateGroupStatus>> GroupAsyncWithHttpInfo (CreateGroupAction createGroupAction);
        /// <summary>
        /// Make participant in the group an administrator
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        System.Threading.Tasks.Task<GroupParticipantStatus> PromoteGroupParticipantAsync (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Make participant in the group an administrator
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> PromoteGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction);
        /// <summary>
        /// Open chat for reading messages
        /// </summary>
        /// <remarks>
        /// Use this method to make users see their messages read.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>Task of ReadChatStatus</returns>
        System.Threading.Tasks.Task<ReadChatStatus> ReadChatAsync (ReadChatAction readChatAction);

        /// <summary>
        /// Open chat for reading messages
        /// </summary>
        /// <remarks>
        /// Use this method to make users see their messages read.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>Task of ApiResponse (ReadChatStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<ReadChatStatus>> ReadChatAsyncWithHttpInfo (ReadChatAction readChatAction);
        /// <summary>
        /// Remove participant from a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        System.Threading.Tasks.Task<GroupParticipantStatus> RemoveGroupParticipantAsync (GroupParticipantAction groupParticipantAction);

        /// <summary>
        /// Remove participant from a group
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> RemoveGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class Class3ChatsApi : IClass3ChatsApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="Class3ChatsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public Class3ChatsApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class3ChatsApi"/> class
        /// </summary>
        /// <returns></returns>
        public Class3ChatsApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class3ChatsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public Class3ChatsApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Adding participant to a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        public GroupParticipantStatus AddGroupParticipant (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = AddGroupParticipantWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Adding participant to a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        public ApiResponse<GroupParticipantStatus> AddGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->AddGroupParticipant");

            var localVarPath = "/addGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Adding participant to a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        public async System.Threading.Tasks.Task<GroupParticipantStatus> AddGroupParticipantAsync (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = await AddGroupParticipantAsyncWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Adding participant to a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> AddGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->AddGroupParticipant");

            var localVarPath = "/addGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Demote group participant 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        public GroupParticipantStatus DemoteGroupParticipant (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = DemoteGroupParticipantWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Demote group participant 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        public ApiResponse<GroupParticipantStatus> DemoteGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->DemoteGroupParticipant");

            var localVarPath = "/demoteGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DemoteGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Demote group participant 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        public async System.Threading.Tasks.Task<GroupParticipantStatus> DemoteGroupParticipantAsync (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = await DemoteGroupParticipantAsyncWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Demote group participant 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> DemoteGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->DemoteGroupParticipant");

            var localVarPath = "/demoteGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DemoteGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Get the chat list. The chat list includes avatars.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Chats</returns>
        public Chats GetChats ()
        {
             ApiResponse<Chats> localVarResponse = GetChatsWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get the chat list. The chat list includes avatars.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of Chats</returns>
        public ApiResponse<Chats> GetChatsWithHttpInfo ()
        {

            var localVarPath = "/dialogs";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetChats", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Chats>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Chats) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Chats)));
        }

        /// <summary>
        /// Get the chat list. The chat list includes avatars.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of Chats</returns>
        public async System.Threading.Tasks.Task<Chats> GetChatsAsync ()
        {
             ApiResponse<Chats> localVarResponse = await GetChatsAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get the chat list. The chat list includes avatars.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (Chats)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Chats>> GetChatsAsyncWithHttpInfo ()
        {

            var localVarPath = "/dialogs";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetChats", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Chats>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Chats) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Chats)));
        }

        /// <summary>
        /// Creates a group and sends the message to the created group. The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>CreateGroupStatus</returns>
        public CreateGroupStatus Group (CreateGroupAction createGroupAction)
        {
             ApiResponse<CreateGroupStatus> localVarResponse = GroupWithHttpInfo(createGroupAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Creates a group and sends the message to the created group. The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>ApiResponse of CreateGroupStatus</returns>
        public ApiResponse<CreateGroupStatus> GroupWithHttpInfo (CreateGroupAction createGroupAction)
        {
            // verify the required parameter 'createGroupAction' is set
            if (createGroupAction == null)
                throw new ApiException(400, "Missing required parameter 'createGroupAction' when calling Class3ChatsApi->Group");

            var localVarPath = "/group";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (createGroupAction != null && createGroupAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(createGroupAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = createGroupAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Group", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CreateGroupStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CreateGroupStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CreateGroupStatus)));
        }

        /// <summary>
        /// Creates a group and sends the message to the created group. The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>Task of CreateGroupStatus</returns>
        public async System.Threading.Tasks.Task<CreateGroupStatus> GroupAsync (CreateGroupAction createGroupAction)
        {
             ApiResponse<CreateGroupStatus> localVarResponse = await GroupAsyncWithHttpInfo(createGroupAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Creates a group and sends the message to the created group. The group will be added to the queue for sending and sooner or later it will be created, even if the phone is disconnected from the Internet or the authorization is not passed.   2 Oct 2018 update: chatId parameter will be returned if group was created on your phone within 20 second.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="createGroupAction"></param>
        /// <returns>Task of ApiResponse (CreateGroupStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CreateGroupStatus>> GroupAsyncWithHttpInfo (CreateGroupAction createGroupAction)
        {
            // verify the required parameter 'createGroupAction' is set
            if (createGroupAction == null)
                throw new ApiException(400, "Missing required parameter 'createGroupAction' when calling Class3ChatsApi->Group");

            var localVarPath = "/group";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (createGroupAction != null && createGroupAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(createGroupAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = createGroupAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Group", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CreateGroupStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (CreateGroupStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CreateGroupStatus)));
        }

        /// <summary>
        /// Make participant in the group an administrator 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        public GroupParticipantStatus PromoteGroupParticipant (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = PromoteGroupParticipantWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Make participant in the group an administrator 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        public ApiResponse<GroupParticipantStatus> PromoteGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->PromoteGroupParticipant");

            var localVarPath = "/promoteGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PromoteGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Make participant in the group an administrator 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        public async System.Threading.Tasks.Task<GroupParticipantStatus> PromoteGroupParticipantAsync (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = await PromoteGroupParticipantAsyncWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Make participant in the group an administrator 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> PromoteGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->PromoteGroupParticipant");

            var localVarPath = "/promoteGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PromoteGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Open chat for reading messages Use this method to make users see their messages read.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>ReadChatStatus</returns>
        public ReadChatStatus ReadChat (ReadChatAction readChatAction)
        {
             ApiResponse<ReadChatStatus> localVarResponse = ReadChatWithHttpInfo(readChatAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Open chat for reading messages Use this method to make users see their messages read.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>ApiResponse of ReadChatStatus</returns>
        public ApiResponse<ReadChatStatus> ReadChatWithHttpInfo (ReadChatAction readChatAction)
        {
            // verify the required parameter 'readChatAction' is set
            if (readChatAction == null)
                throw new ApiException(400, "Missing required parameter 'readChatAction' when calling Class3ChatsApi->ReadChat");

            var localVarPath = "/readChat";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (readChatAction != null && readChatAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(readChatAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = readChatAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ReadChat", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ReadChatStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ReadChatStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ReadChatStatus)));
        }

        /// <summary>
        /// Open chat for reading messages Use this method to make users see their messages read.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>Task of ReadChatStatus</returns>
        public async System.Threading.Tasks.Task<ReadChatStatus> ReadChatAsync (ReadChatAction readChatAction)
        {
             ApiResponse<ReadChatStatus> localVarResponse = await ReadChatAsyncWithHttpInfo(readChatAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Open chat for reading messages Use this method to make users see their messages read.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="readChatAction"></param>
        /// <returns>Task of ApiResponse (ReadChatStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ReadChatStatus>> ReadChatAsyncWithHttpInfo (ReadChatAction readChatAction)
        {
            // verify the required parameter 'readChatAction' is set
            if (readChatAction == null)
                throw new ApiException(400, "Missing required parameter 'readChatAction' when calling Class3ChatsApi->ReadChat");

            var localVarPath = "/readChat";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (readChatAction != null && readChatAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(readChatAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = readChatAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ReadChat", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ReadChatStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ReadChatStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ReadChatStatus)));
        }

        /// <summary>
        /// Remove participant from a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>GroupParticipantStatus</returns>
        public GroupParticipantStatus RemoveGroupParticipant (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = RemoveGroupParticipantWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Remove participant from a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>ApiResponse of GroupParticipantStatus</returns>
        public ApiResponse<GroupParticipantStatus> RemoveGroupParticipantWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->RemoveGroupParticipant");

            var localVarPath = "/removeGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("RemoveGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

        /// <summary>
        /// Remove participant from a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of GroupParticipantStatus</returns>
        public async System.Threading.Tasks.Task<GroupParticipantStatus> RemoveGroupParticipantAsync (GroupParticipantAction groupParticipantAction)
        {
             ApiResponse<GroupParticipantStatus> localVarResponse = await RemoveGroupParticipantAsyncWithHttpInfo(groupParticipantAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Remove participant from a group 
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupParticipantAction"></param>
        /// <returns>Task of ApiResponse (GroupParticipantStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupParticipantStatus>> RemoveGroupParticipantAsyncWithHttpInfo (GroupParticipantAction groupParticipantAction)
        {
            // verify the required parameter 'groupParticipantAction' is set
            if (groupParticipantAction == null)
                throw new ApiException(400, "Missing required parameter 'groupParticipantAction' when calling Class3ChatsApi->RemoveGroupParticipant");

            var localVarPath = "/removeGroupParticipant";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/x-www-form-urlencoded", 
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupParticipantAction != null && groupParticipantAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupParticipantAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupParticipantAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("RemoveGroupParticipant", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupParticipantStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (GroupParticipantStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupParticipantStatus)));
        }

    }
}
