/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IClass5QueuesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Clear outbound actions queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of actions in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ClearActionsQueueStatus</returns>
        ClearActionsQueueStatus ClearActionsQueue ();

        /// <summary>
        /// Clear outbound actions queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of actions in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ClearActionsQueueStatus</returns>
        ApiResponse<ClearActionsQueueStatus> ClearActionsQueueWithHttpInfo ();
        /// <summary>
        /// Clear outbound messages queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of messages in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ClearMessagesQueueStatus</returns>
        ClearMessagesQueueStatus ClearMessagesQueue ();

        /// <summary>
        /// Clear outbound messages queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of messages in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ClearMessagesQueueStatus</returns>
        ApiResponse<ClearMessagesQueueStatus> ClearMessagesQueueWithHttpInfo ();
        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>OutboundActions</returns>
        OutboundActions ShowActionsQueue ();

        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of OutboundActions</returns>
        ApiResponse<OutboundActions> ShowActionsQueueWithHttpInfo ();
        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>OutboundMessages</returns>
        OutboundMessages ShowMessagesQueue ();

        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of OutboundMessages</returns>
        ApiResponse<OutboundMessages> ShowMessagesQueueWithHttpInfo ();
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Clear outbound actions queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of actions in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ClearActionsQueueStatus</returns>
        System.Threading.Tasks.Task<ClearActionsQueueStatus> ClearActionsQueueAsync ();

        /// <summary>
        /// Clear outbound actions queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of actions in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ClearActionsQueueStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<ClearActionsQueueStatus>> ClearActionsQueueAsyncWithHttpInfo ();
        /// <summary>
        /// Clear outbound messages queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of messages in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ClearMessagesQueueStatus</returns>
        System.Threading.Tasks.Task<ClearMessagesQueueStatus> ClearMessagesQueueAsync ();

        /// <summary>
        /// Clear outbound messages queue.
        /// </summary>
        /// <remarks>
        /// This method is needed when you accidentally sent thousands of messages in a row.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ClearMessagesQueueStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<ClearMessagesQueueStatus>> ClearMessagesQueueAsyncWithHttpInfo ();
        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of OutboundActions</returns>
        System.Threading.Tasks.Task<OutboundActions> ShowActionsQueueAsync ();

        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (OutboundActions)</returns>
        System.Threading.Tasks.Task<ApiResponse<OutboundActions>> ShowActionsQueueAsyncWithHttpInfo ();
        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of OutboundMessages</returns>
        System.Threading.Tasks.Task<OutboundMessages> ShowMessagesQueueAsync ();

        /// <summary>
        /// Get outbound messages queue.
        /// </summary>
        /// <remarks>
        /// When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (OutboundMessages)</returns>
        System.Threading.Tasks.Task<ApiResponse<OutboundMessages>> ShowMessagesQueueAsyncWithHttpInfo ();
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class Class5QueuesApi : IClass5QueuesApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="Class5QueuesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public Class5QueuesApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class5QueuesApi"/> class
        /// </summary>
        /// <returns></returns>
        public Class5QueuesApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class5QueuesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public Class5QueuesApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Clear outbound actions queue. This method is needed when you accidentally sent thousands of actions in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ClearActionsQueueStatus</returns>
        public ClearActionsQueueStatus ClearActionsQueue ()
        {
             ApiResponse<ClearActionsQueueStatus> localVarResponse = ClearActionsQueueWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Clear outbound actions queue. This method is needed when you accidentally sent thousands of actions in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ClearActionsQueueStatus</returns>
        public ApiResponse<ClearActionsQueueStatus> ClearActionsQueueWithHttpInfo ()
        {

            var localVarPath = "/clearActionsQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ClearActionsQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ClearActionsQueueStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ClearActionsQueueStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ClearActionsQueueStatus)));
        }

        /// <summary>
        /// Clear outbound actions queue. This method is needed when you accidentally sent thousands of actions in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ClearActionsQueueStatus</returns>
        public async System.Threading.Tasks.Task<ClearActionsQueueStatus> ClearActionsQueueAsync ()
        {
             ApiResponse<ClearActionsQueueStatus> localVarResponse = await ClearActionsQueueAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Clear outbound actions queue. This method is needed when you accidentally sent thousands of actions in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ClearActionsQueueStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ClearActionsQueueStatus>> ClearActionsQueueAsyncWithHttpInfo ()
        {

            var localVarPath = "/clearActionsQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ClearActionsQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ClearActionsQueueStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ClearActionsQueueStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ClearActionsQueueStatus)));
        }

        /// <summary>
        /// Clear outbound messages queue. This method is needed when you accidentally sent thousands of messages in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ClearMessagesQueueStatus</returns>
        public ClearMessagesQueueStatus ClearMessagesQueue ()
        {
             ApiResponse<ClearMessagesQueueStatus> localVarResponse = ClearMessagesQueueWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Clear outbound messages queue. This method is needed when you accidentally sent thousands of messages in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ClearMessagesQueueStatus</returns>
        public ApiResponse<ClearMessagesQueueStatus> ClearMessagesQueueWithHttpInfo ()
        {

            var localVarPath = "/clearMessagesQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ClearMessagesQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ClearMessagesQueueStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ClearMessagesQueueStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ClearMessagesQueueStatus)));
        }

        /// <summary>
        /// Clear outbound messages queue. This method is needed when you accidentally sent thousands of messages in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ClearMessagesQueueStatus</returns>
        public async System.Threading.Tasks.Task<ClearMessagesQueueStatus> ClearMessagesQueueAsync ()
        {
             ApiResponse<ClearMessagesQueueStatus> localVarResponse = await ClearMessagesQueueAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Clear outbound messages queue. This method is needed when you accidentally sent thousands of messages in a row.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ClearMessagesQueueStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ClearMessagesQueueStatus>> ClearMessagesQueueAsyncWithHttpInfo ()
        {

            var localVarPath = "/clearMessagesQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ClearMessagesQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ClearMessagesQueueStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ClearMessagesQueueStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ClearMessagesQueueStatus)));
        }

        /// <summary>
        /// Get outbound messages queue. When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>OutboundActions</returns>
        public OutboundActions ShowActionsQueue ()
        {
             ApiResponse<OutboundActions> localVarResponse = ShowActionsQueueWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get outbound messages queue. When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of OutboundActions</returns>
        public ApiResponse<OutboundActions> ShowActionsQueueWithHttpInfo ()
        {

            var localVarPath = "/showActionsQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ShowActionsQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<OutboundActions>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (OutboundActions) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(OutboundActions)));
        }

        /// <summary>
        /// Get outbound messages queue. When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of OutboundActions</returns>
        public async System.Threading.Tasks.Task<OutboundActions> ShowActionsQueueAsync ()
        {
             ApiResponse<OutboundActions> localVarResponse = await ShowActionsQueueAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get outbound messages queue. When you create an action, all actions are queued up. If an action is not executed, it remains in the queue and will be sent for execution in time. again. The action cannot be executed due to the status of the device connected to the account.  This method give the last 100 actions in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (OutboundActions)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<OutboundActions>> ShowActionsQueueAsyncWithHttpInfo ()
        {

            var localVarPath = "/showActionsQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ShowActionsQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<OutboundActions>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (OutboundActions) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(OutboundActions)));
        }

        /// <summary>
        /// Get outbound messages queue. When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>OutboundMessages</returns>
        public OutboundMessages ShowMessagesQueue ()
        {
             ApiResponse<OutboundMessages> localVarResponse = ShowMessagesQueueWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get outbound messages queue. When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of OutboundMessages</returns>
        public ApiResponse<OutboundMessages> ShowMessagesQueueWithHttpInfo ()
        {

            var localVarPath = "/showMessagesQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ShowMessagesQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<OutboundMessages>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (OutboundMessages) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(OutboundMessages)));
        }

        /// <summary>
        /// Get outbound messages queue. When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of OutboundMessages</returns>
        public async System.Threading.Tasks.Task<OutboundMessages> ShowMessagesQueueAsync ()
        {
             ApiResponse<OutboundMessages> localVarResponse = await ShowMessagesQueueAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get outbound messages queue. When sending messages, all messages are in the queue. If the message is not sent, then it remains in the queue and in time it will be sent again. The message may not be sent due to the status of the device connected to the account.   This method give the last 100 messages in the queue.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (OutboundMessages)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<OutboundMessages>> ShowMessagesQueueAsyncWithHttpInfo ()
        {

            var localVarPath = "/showMessagesQueue";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ShowMessagesQueue", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<OutboundMessages>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (OutboundMessages) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(OutboundMessages)));
        }

    }
}
