/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IClass7TestingApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns instance status changes history.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Statuses</returns>
        Statuses InstanceStatuses (int minTime = default(int), int maxTime = default(int));

        /// <summary>
        /// Returns instance status changes history.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>ApiResponse of Statuses</returns>
        ApiResponse<Statuses> InstanceStatusesWithHttpInfo (int minTime = default(int), int maxTime = default(int));
        /// <summary>
        /// Returns webhook status for message.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>WebhookStatus</returns>
        WebhookStatus WebhookStatuses (string msgId);

        /// <summary>
        /// Returns webhook status for message.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>ApiResponse of WebhookStatus</returns>
        ApiResponse<WebhookStatus> WebhookStatusesWithHttpInfo (string msgId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns instance status changes history.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Task of Statuses</returns>
        System.Threading.Tasks.Task<Statuses> InstanceStatusesAsync (int minTime = default(int), int maxTime = default(int));

        /// <summary>
        /// Returns instance status changes history.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Task of ApiResponse (Statuses)</returns>
        System.Threading.Tasks.Task<ApiResponse<Statuses>> InstanceStatusesAsyncWithHttpInfo (int minTime = default(int), int maxTime = default(int));
        /// <summary>
        /// Returns webhook status for message.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>Task of WebhookStatus</returns>
        System.Threading.Tasks.Task<WebhookStatus> WebhookStatusesAsync (string msgId);

        /// <summary>
        /// Returns webhook status for message.
        /// </summary>
        /// <remarks>
        /// Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>Task of ApiResponse (WebhookStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<WebhookStatus>> WebhookStatusesAsyncWithHttpInfo (string msgId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class Class7TestingApi : IClass7TestingApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="Class7TestingApi"/> class.
        /// </summary>
        /// <returns></returns>
        public Class7TestingApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class7TestingApi"/> class
        /// </summary>
        /// <returns></returns>
        public Class7TestingApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class7TestingApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public Class7TestingApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns instance status changes history. Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Statuses</returns>
        public Statuses InstanceStatuses (int minTime = default(int), int maxTime = default(int))
        {
             ApiResponse<Statuses> localVarResponse = InstanceStatusesWithHttpInfo(minTime, maxTime);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns instance status changes history. Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>ApiResponse of Statuses</returns>
        public ApiResponse<Statuses> InstanceStatusesWithHttpInfo (int minTime = default(int), int maxTime = default(int))
        {

            var localVarPath = "/instanceStatuses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (minTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "min_time", minTime)); // query parameter
            if (maxTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "max_time", maxTime)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstanceStatuses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Statuses>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Statuses) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Statuses)));
        }

        /// <summary>
        /// Returns instance status changes history. Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Task of Statuses</returns>
        public async System.Threading.Tasks.Task<Statuses> InstanceStatusesAsync (int minTime = default(int), int maxTime = default(int))
        {
             ApiResponse<Statuses> localVarResponse = await InstanceStatusesAsyncWithHttpInfo(minTime, maxTime);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns instance status changes history. Requires enable \&quot;instanceStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="minTime">Filter statuses received after specified date. Example: 946684800. (optional)</param>
        /// <param name="maxTime">Filter statuses received before specified date. Example: 946684800. (optional)</param>
        /// <returns>Task of ApiResponse (Statuses)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Statuses>> InstanceStatusesAsyncWithHttpInfo (int minTime = default(int), int maxTime = default(int))
        {

            var localVarPath = "/instanceStatuses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (minTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "min_time", minTime)); // query parameter
            if (maxTime != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "max_time", maxTime)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstanceStatuses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Statuses>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (Statuses) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Statuses)));
        }

        /// <summary>
        /// Returns webhook status for message. Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>WebhookStatus</returns>
        public WebhookStatus WebhookStatuses (string msgId)
        {
             ApiResponse<WebhookStatus> localVarResponse = WebhookStatusesWithHttpInfo(msgId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns webhook status for message. Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>ApiResponse of WebhookStatus</returns>
        public ApiResponse<WebhookStatus> WebhookStatusesWithHttpInfo (string msgId)
        {
            // verify the required parameter 'msgId' is set
            if (msgId == null)
                throw new ApiException(400, "Missing required parameter 'msgId' when calling Class7TestingApi->WebhookStatuses");

            var localVarPath = "/webhookStatus";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (msgId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "msgId", msgId)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebhookStatuses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<WebhookStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (WebhookStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(WebhookStatus)));
        }

        /// <summary>
        /// Returns webhook status for message. Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>Task of WebhookStatus</returns>
        public async System.Threading.Tasks.Task<WebhookStatus> WebhookStatusesAsync (string msgId)
        {
             ApiResponse<WebhookStatus> localVarResponse = await WebhookStatusesAsyncWithHttpInfo(msgId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns webhook status for message. Requires enable \&quot;webhookStatuses\&quot; option for collecting data.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="msgId">Message ID. Example: false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F.</param>
        /// <returns>Task of ApiResponse (WebhookStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<WebhookStatus>> WebhookStatusesAsyncWithHttpInfo (string msgId)
        {
            // verify the required parameter 'msgId' is set
            if (msgId == null)
                throw new ApiException(400, "Missing required parameter 'msgId' when calling Class7TestingApi->WebhookStatuses");

            var localVarPath = "/webhookStatus";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (msgId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "msgId", msgId)); // query parameter

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebhookStatuses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<WebhookStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (WebhookStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(WebhookStatus)));
        }

    }
}
