/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// Ack
    /// </summary>
    [DataContract]
    public partial class Ack :  IEquatable<Ack>, IValidatableObject
    {
        /// <summary>
        /// type of the message status
        /// </summary>
        /// <value>type of the message status</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            /// <summary>
            /// Enum Delivered for value: delivered
            /// </summary>
            [EnumMember(Value = "delivered")]
            Delivered = 1,

            /// <summary>
            /// Enum Viewed for value: viewed
            /// </summary>
            [EnumMember(Value = "viewed")]
            Viewed = 2

        }

        /// <summary>
        /// type of the message status
        /// </summary>
        /// <value>type of the message status</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public StatusEnum? Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="Ack" /> class.
        /// </summary>
        /// <param name="id">unique id.</param>
        /// <param name="queueNumber">message id in queue.</param>
        /// <param name="chatId">chat ID.</param>
        /// <param name="status">type of the message status.</param>
        public Ack(string id = default(string), int queueNumber = default(int), string chatId = default(string), StatusEnum? status = default(StatusEnum?))
        {
            this.Id = id;
            this.QueueNumber = queueNumber;
            this.ChatId = chatId;
            this.Status = status;
        }
        
        /// <summary>
        /// unique id
        /// </summary>
        /// <value>unique id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// message id in queue
        /// </summary>
        /// <value>message id in queue</value>
        [DataMember(Name="queueNumber", EmitDefaultValue=false)]
        public int QueueNumber { get; set; }

        /// <summary>
        /// chat ID
        /// </summary>
        /// <value>chat ID</value>
        [DataMember(Name="chatId", EmitDefaultValue=false)]
        public string ChatId { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Ack {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  QueueNumber: ").Append(QueueNumber).Append("\n");
            sb.Append("  ChatId: ").Append(ChatId).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Ack);
        }

        /// <summary>
        /// Returns true if Ack instances are equal
        /// </summary>
        /// <param name="input">Instance of Ack to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Ack input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.QueueNumber == input.QueueNumber ||
                    (this.QueueNumber != null &&
                    this.QueueNumber.Equals(input.QueueNumber))
                ) && 
                (
                    this.ChatId == input.ChatId ||
                    (this.ChatId != null &&
                    this.ChatId.Equals(input.ChatId))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.QueueNumber != null)
                    hashCode = hashCode * 59 + this.QueueNumber.GetHashCode();
                if (this.ChatId != null)
                    hashCode = hashCode * 59 + this.ChatId.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
