/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// BanTestStatus
    /// </summary>
    [DataContract]
    public partial class BanTestStatus :  IEquatable<BanTestStatus>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BanTestStatus" /> class.
        /// </summary>
        /// <param name="banned">banned.</param>
        /// <param name="message">message.</param>
        /// <param name="phone">Test phone number.</param>
        /// <param name="banPhoneMask">Test regex.</param>
        public BanTestStatus(bool banned = default(bool), string message = default(string), string phone = default(string), string banPhoneMask = default(string))
        {
            this.Banned = banned;
            this.Message = message;
            this.Phone = phone;
            this.BanPhoneMask = banPhoneMask;
        }
        
        /// <summary>
        /// Gets or Sets Banned
        /// </summary>
        [DataMember(Name="banned", EmitDefaultValue=false)]
        public bool Banned { get; set; }

        /// <summary>
        /// Gets or Sets Message
        /// </summary>
        [DataMember(Name="message", EmitDefaultValue=false)]
        public string Message { get; set; }

        /// <summary>
        /// Test phone number
        /// </summary>
        /// <value>Test phone number</value>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public string Phone { get; set; }

        /// <summary>
        /// Test regex
        /// </summary>
        /// <value>Test regex</value>
        [DataMember(Name="banPhoneMask", EmitDefaultValue=false)]
        public string BanPhoneMask { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BanTestStatus {\n");
            sb.Append("  Banned: ").Append(Banned).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("  BanPhoneMask: ").Append(BanPhoneMask).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BanTestStatus);
        }

        /// <summary>
        /// Returns true if BanTestStatus instances are equal
        /// </summary>
        /// <param name="input">Instance of BanTestStatus to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BanTestStatus input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Banned == input.Banned ||
                    (this.Banned != null &&
                    this.Banned.Equals(input.Banned))
                ) && 
                (
                    this.Message == input.Message ||
                    (this.Message != null &&
                    this.Message.Equals(input.Message))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                ) && 
                (
                    this.BanPhoneMask == input.BanPhoneMask ||
                    (this.BanPhoneMask != null &&
                    this.BanPhoneMask.Equals(input.BanPhoneMask))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Banned != null)
                    hashCode = hashCode * 59 + this.Banned.GetHashCode();
                if (this.Message != null)
                    hashCode = hashCode * 59 + this.Message.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                if (this.BanPhoneMask != null)
                    hashCode = hashCode * 59 + this.BanPhoneMask.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
