/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CreateGroupAction
    /// </summary>
    [DataContract]
    public partial class CreateGroupAction :  IEquatable<CreateGroupAction>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CreateGroupAction" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CreateGroupAction() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CreateGroupAction" /> class.
        /// </summary>
        /// <param name="groupName">Name of the group being created (required).</param>
        /// <param name="chatIds">**Required if phones is not set**  An array of new participients chatIds. .</param>
        /// <param name="phones">**Required if chatIds is not set**  An array of phones starting with the country code. You do not need to add your number.   USA example: [17472822486&#39;]..</param>
        /// <param name="messageText">The text of the message that will be sent to the group when it is created. If you do not set a parameter, the message will not be sent.</param>
        public CreateGroupAction(string groupName = default(string), List<string> chatIds = default(List<string>), List<int> phones = default(List<int>), string messageText = default(string))
        {
            // to ensure "groupName" is required (not null)
            if (groupName == null)
            {
                throw new InvalidDataException("groupName is a required property for CreateGroupAction and cannot be null");
            }
            else
            {
                this.GroupName = groupName;
            }
            
            this.ChatIds = chatIds;
            this.Phones = phones;
            this.MessageText = messageText;
        }
        
        /// <summary>
        /// Name of the group being created
        /// </summary>
        /// <value>Name of the group being created</value>
        [DataMember(Name="groupName", EmitDefaultValue=false)]
        public string GroupName { get; set; }

        /// <summary>
        /// **Required if phones is not set**  An array of new participients chatIds. 
        /// </summary>
        /// <value>**Required if phones is not set**  An array of new participients chatIds. </value>
        [DataMember(Name="chatIds", EmitDefaultValue=false)]
        public List<string> ChatIds { get; set; }

        /// <summary>
        /// **Required if chatIds is not set**  An array of phones starting with the country code. You do not need to add your number.   USA example: [17472822486&#39;].
        /// </summary>
        /// <value>**Required if chatIds is not set**  An array of phones starting with the country code. You do not need to add your number.   USA example: [17472822486&#39;].</value>
        [DataMember(Name="phones", EmitDefaultValue=false)]
        public List<int> Phones { get; set; }

        /// <summary>
        /// The text of the message that will be sent to the group when it is created. If you do not set a parameter, the message will not be sent
        /// </summary>
        /// <value>The text of the message that will be sent to the group when it is created. If you do not set a parameter, the message will not be sent</value>
        [DataMember(Name="messageText", EmitDefaultValue=false)]
        public string MessageText { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CreateGroupAction {\n");
            sb.Append("  GroupName: ").Append(GroupName).Append("\n");
            sb.Append("  ChatIds: ").Append(ChatIds).Append("\n");
            sb.Append("  Phones: ").Append(Phones).Append("\n");
            sb.Append("  MessageText: ").Append(MessageText).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CreateGroupAction);
        }

        /// <summary>
        /// Returns true if CreateGroupAction instances are equal
        /// </summary>
        /// <param name="input">Instance of CreateGroupAction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CreateGroupAction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.GroupName == input.GroupName ||
                    (this.GroupName != null &&
                    this.GroupName.Equals(input.GroupName))
                ) && 
                (
                    this.ChatIds == input.ChatIds ||
                    this.ChatIds != null &&
                    input.ChatIds != null &&
                    this.ChatIds.SequenceEqual(input.ChatIds)
                ) && 
                (
                    this.Phones == input.Phones ||
                    this.Phones != null &&
                    input.Phones != null &&
                    this.Phones.SequenceEqual(input.Phones)
                ) && 
                (
                    this.MessageText == input.MessageText ||
                    (this.MessageText != null &&
                    this.MessageText.Equals(input.MessageText))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.GroupName != null)
                    hashCode = hashCode * 59 + this.GroupName.GetHashCode();
                if (this.ChatIds != null)
                    hashCode = hashCode * 59 + this.ChatIds.GetHashCode();
                if (this.Phones != null)
                    hashCode = hashCode * 59 + this.Phones.GetHashCode();
                if (this.MessageText != null)
                    hashCode = hashCode * 59 + this.MessageText.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
