/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CreateGroupStatus
    /// </summary>
    [DataContract]
    public partial class CreateGroupStatus :  IEquatable<CreateGroupStatus>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CreateGroupStatus" /> class.
        /// </summary>
        /// <param name="created">created.</param>
        /// <param name="message">Group creation status.</param>
        /// <param name="chatId">Created group id.</param>
        /// <param name="groupInviteLink">Link invitation to the group.</param>
        public CreateGroupStatus(bool created = default(bool), string message = default(string), string chatId = default(string), string groupInviteLink = default(string))
        {
            this.Created = created;
            this.Message = message;
            this.ChatId = chatId;
            this.GroupInviteLink = groupInviteLink;
        }
        
        /// <summary>
        /// Gets or Sets Created
        /// </summary>
        [DataMember(Name="created", EmitDefaultValue=false)]
        public bool Created { get; set; }

        /// <summary>
        /// Group creation status
        /// </summary>
        /// <value>Group creation status</value>
        [DataMember(Name="message", EmitDefaultValue=false)]
        public string Message { get; set; }

        /// <summary>
        /// Created group id
        /// </summary>
        /// <value>Created group id</value>
        [DataMember(Name="chatId", EmitDefaultValue=false)]
        public string ChatId { get; set; }

        /// <summary>
        /// Link invitation to the group
        /// </summary>
        /// <value>Link invitation to the group</value>
        [DataMember(Name="groupInviteLink", EmitDefaultValue=false)]
        public string GroupInviteLink { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CreateGroupStatus {\n");
            sb.Append("  Created: ").Append(Created).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("  ChatId: ").Append(ChatId).Append("\n");
            sb.Append("  GroupInviteLink: ").Append(GroupInviteLink).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CreateGroupStatus);
        }

        /// <summary>
        /// Returns true if CreateGroupStatus instances are equal
        /// </summary>
        /// <param name="input">Instance of CreateGroupStatus to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CreateGroupStatus input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Created == input.Created ||
                    (this.Created != null &&
                    this.Created.Equals(input.Created))
                ) && 
                (
                    this.Message == input.Message ||
                    (this.Message != null &&
                    this.Message.Equals(input.Message))
                ) && 
                (
                    this.ChatId == input.ChatId ||
                    (this.ChatId != null &&
                    this.ChatId.Equals(input.ChatId))
                ) && 
                (
                    this.GroupInviteLink == input.GroupInviteLink ||
                    (this.GroupInviteLink != null &&
                    this.GroupInviteLink.Equals(input.GroupInviteLink))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Created != null)
                    hashCode = hashCode * 59 + this.Created.GetHashCode();
                if (this.Message != null)
                    hashCode = hashCode * 59 + this.Message.GetHashCode();
                if (this.ChatId != null)
                    hashCode = hashCode * 59 + this.ChatId.GetHashCode();
                if (this.GroupInviteLink != null)
                    hashCode = hashCode * 59 + this.GroupInviteLink.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
