/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// InstanceStatus
    /// </summary>
    [DataContract]
    public partial class InstanceStatus :  IEquatable<InstanceStatus>, IValidatableObject
    {
        /// <summary>
        /// Instance Status
        /// </summary>
        /// <value>Instance Status</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum AccountStatusEnum
        {
            /// <summary>
            /// Enum Gotqrcode for value: got qr code
            /// </summary>
            [EnumMember(Value = "got qr code")]
            Gotqrcode = 1,

            /// <summary>
            /// Enum Authenticated for value: authenticated
            /// </summary>
            [EnumMember(Value = "authenticated")]
            Authenticated = 2,

            /// <summary>
            /// Enum Loading for value: loading
            /// </summary>
            [EnumMember(Value = "loading")]
            Loading = 3,

            /// <summary>
            /// Enum Init for value: init
            /// </summary>
            [EnumMember(Value = "init")]
            Init = 4,

            /// <summary>
            /// Enum Notpaid for value: not_paid
            /// </summary>
            [EnumMember(Value = "not_paid")]
            Notpaid = 5

        }

        /// <summary>
        /// Instance Status
        /// </summary>
        /// <value>Instance Status</value>
        [DataMember(Name="accountStatus", EmitDefaultValue=false)]
        public AccountStatusEnum? AccountStatus { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="InstanceStatus" /> class.
        /// </summary>
        /// <param name="accountStatus">Instance Status.</param>
        /// <param name="qrCode">Base64-encoded contents of the QR code.</param>
        /// <param name="statusData">statusData.</param>
        public InstanceStatus(AccountStatusEnum? accountStatus = default(AccountStatusEnum?), byte[] qrCode = default(byte[]), InstanceStatusStatusData statusData = default(InstanceStatusStatusData))
        {
            this.AccountStatus = accountStatus;
            this.QrCode = qrCode;
            this.StatusData = statusData;
        }
        

        /// <summary>
        /// Base64-encoded contents of the QR code
        /// </summary>
        /// <value>Base64-encoded contents of the QR code</value>
        [DataMember(Name="qrCode", EmitDefaultValue=false)]
        public byte[] QrCode { get; set; }

        /// <summary>
        /// Gets or Sets StatusData
        /// </summary>
        [DataMember(Name="statusData", EmitDefaultValue=false)]
        public InstanceStatusStatusData StatusData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InstanceStatus {\n");
            sb.Append("  AccountStatus: ").Append(AccountStatus).Append("\n");
            sb.Append("  QrCode: ").Append(QrCode).Append("\n");
            sb.Append("  StatusData: ").Append(StatusData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InstanceStatus);
        }

        /// <summary>
        /// Returns true if InstanceStatus instances are equal
        /// </summary>
        /// <param name="input">Instance of InstanceStatus to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InstanceStatus input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AccountStatus == input.AccountStatus ||
                    (this.AccountStatus != null &&
                    this.AccountStatus.Equals(input.AccountStatus))
                ) && 
                (
                    this.QrCode == input.QrCode ||
                    (this.QrCode != null &&
                    this.QrCode.Equals(input.QrCode))
                ) && 
                (
                    this.StatusData == input.StatusData ||
                    (this.StatusData != null &&
                    this.StatusData.Equals(input.StatusData))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AccountStatus != null)
                    hashCode = hashCode * 59 + this.AccountStatus.GetHashCode();
                if (this.QrCode != null)
                    hashCode = hashCode * 59 + this.QrCode.GetHashCode();
                if (this.StatusData != null)
                    hashCode = hashCode * 59 + this.StatusData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
