/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// Actions that can be applied to change the status
    /// </summary>
    [DataContract]
    public partial class InstanceStatusStatusDataActions :  IEquatable<InstanceStatusStatusDataActions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InstanceStatusStatusDataActions" /> class.
        /// </summary>
        /// <param name="expiry">expiry.</param>
        /// <param name="retry">retry.</param>
        /// <param name="logout">logout.</param>
        /// <param name="takeover">takeover.</param>
        /// <param name="learnMore">learnMore.</param>
        public InstanceStatusStatusDataActions(InstanceStatusAction expiry = default(InstanceStatusAction), InstanceStatusAction retry = default(InstanceStatusAction), InstanceStatusAction logout = default(InstanceStatusAction), InstanceStatusAction takeover = default(InstanceStatusAction), InstanceStatusLink learnMore = default(InstanceStatusLink))
        {
            this.Expiry = expiry;
            this.Retry = retry;
            this.Logout = logout;
            this.Takeover = takeover;
            this.LearnMore = learnMore;
        }
        
        /// <summary>
        /// Gets or Sets Expiry
        /// </summary>
        [DataMember(Name="expiry", EmitDefaultValue=false)]
        public InstanceStatusAction Expiry { get; set; }

        /// <summary>
        /// Gets or Sets Retry
        /// </summary>
        [DataMember(Name="retry", EmitDefaultValue=false)]
        public InstanceStatusAction Retry { get; set; }

        /// <summary>
        /// Gets or Sets Logout
        /// </summary>
        [DataMember(Name="logout", EmitDefaultValue=false)]
        public InstanceStatusAction Logout { get; set; }

        /// <summary>
        /// Gets or Sets Takeover
        /// </summary>
        [DataMember(Name="takeover", EmitDefaultValue=false)]
        public InstanceStatusAction Takeover { get; set; }

        /// <summary>
        /// Gets or Sets LearnMore
        /// </summary>
        [DataMember(Name="learn_more", EmitDefaultValue=false)]
        public InstanceStatusLink LearnMore { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InstanceStatusStatusDataActions {\n");
            sb.Append("  Expiry: ").Append(Expiry).Append("\n");
            sb.Append("  Retry: ").Append(Retry).Append("\n");
            sb.Append("  Logout: ").Append(Logout).Append("\n");
            sb.Append("  Takeover: ").Append(Takeover).Append("\n");
            sb.Append("  LearnMore: ").Append(LearnMore).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InstanceStatusStatusDataActions);
        }

        /// <summary>
        /// Returns true if InstanceStatusStatusDataActions instances are equal
        /// </summary>
        /// <param name="input">Instance of InstanceStatusStatusDataActions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InstanceStatusStatusDataActions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Expiry == input.Expiry ||
                    (this.Expiry != null &&
                    this.Expiry.Equals(input.Expiry))
                ) && 
                (
                    this.Retry == input.Retry ||
                    (this.Retry != null &&
                    this.Retry.Equals(input.Retry))
                ) && 
                (
                    this.Logout == input.Logout ||
                    (this.Logout != null &&
                    this.Logout.Equals(input.Logout))
                ) && 
                (
                    this.Takeover == input.Takeover ||
                    (this.Takeover != null &&
                    this.Takeover.Equals(input.Takeover))
                ) && 
                (
                    this.LearnMore == input.LearnMore ||
                    (this.LearnMore != null &&
                    this.LearnMore.Equals(input.LearnMore))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Expiry != null)
                    hashCode = hashCode * 59 + this.Expiry.GetHashCode();
                if (this.Retry != null)
                    hashCode = hashCode * 59 + this.Retry.GetHashCode();
                if (this.Logout != null)
                    hashCode = hashCode * 59 + this.Logout.GetHashCode();
                if (this.Takeover != null)
                    hashCode = hashCode * 59 + this.Takeover.GetHashCode();
                if (this.LearnMore != null)
                    hashCode = hashCode * 59 + this.LearnMore.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
